#ifndef HIVE_H
#define HIVE_H 1
#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include <mmsystem.h>
#include <math.h>

#define main() WINAPI WinMain (HINSTANCE hThisInstance,HINSTANCE hPrevInstance,LPSTR lpszArgument,int nFunsterStil)

/*Macros for objects*/
#define make_still(o) ((o)->animate=0)
#define make_animate(o) ((o)->animate=1)
#define set_spr(o,s) ((o)->s=s)
#define set_frm(o,i) ((o)->current_frm=i)
#define get_frm(o) ((o)->current_frm)
#define point_in_obj(o,ox,oy,x,y) ((x)>(ox) && (x)<((ox)+(o)->s->first[(o)->current_frm].w) && (y)>(oy) && (y)<((oy)+(o)->s->first[(o)->current_frm].h))
#define collision(o1,x1,y1,o2,x2,y2) (y1+(o1)->s->first[(o1)->current_frm].h<y2 || y1 > y2+(o2)->s->first[(o2)->current_frm].h || x1+(o1)->s->first[(o1)->current_frm].w < x2 || x1 > x2+(o2)->s->first[(o2)->current_frm].w ? 0 : 1)
#define set_renders_per_frm(s,r) ((s)->rndrs_per_frm=r)

#define keydown(c) key[c]

/*Macros for sound*/
#define set_background_music(m) PlaySound(m,NULL,SND_LOOP|SND_ASYNC)
#define shut_up() PlaySound(NULL,NULL,0)

extern int W;
extern int H;

extern char key[256];

extern unsigned int mouse_x,mouse_y;
extern char right,left,leftpress,rightpress,leftrelease,rightrelease;

 
typedef struct
{
 unsigned int w,h;
 char trans;
 HBITMAP hbmp;
 HBITMAP hbmpmask;
}frm;

typedef struct
{
 frm *first; /*NOT a linked list*/
 int frms,rndrs_per_frm;
}spr;

typedef struct
{
 spr *s;
 int current_frm;
 int rndrs;
 char animate;
}obj;

char start(char *name, int fps, int w, int h, char full);
void end(void);
char update(void);
void popup(char *str,char *title);

/*These are internal functions, not to be used by the user but accesible for debug*/
char load_frm(frm *f, char *bmp,char *mask);
void draw_frm(frm *f, int x, int y);
void kill_frm(frm *f);
__int64 time_elasped(void);

/*Primitves*/
void rect(int x1, int y1, int x2, int y2, unsigned char r, unsigned char g, unsigned char b);
void line(int x1, int y1, int x2, int y2, unsigned char r, unsigned char g, unsigned char b);
void cls(void);
void print(char *string, int x, int y);

/*Sprite functions*/
char load_spr(spr *s,int rndrs_per_frm,int frms,...);
void kill_spr(spr *s);

/*Object functions*/
void init_obj(obj *o,spr *s);
void rndr_obj(obj *o,int x,int y);

#endif
